﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;

namespace _01FirstLookThread
{
    class Program
    {
        static void Main(string[] args)
        {
            #region 01.Thread基础
            //Thread thread = Thread.CurrentThread;
            //thread.Name = "Main Thread";
            //string threadMessage = string.Format("Thread ID:{0}\n    Current AppDomainId:{1}\n    " +
            //      "Current ContextId:{2}\n    Thread Name:{3}\n    " +
            //      "Thread State:{4}\n    Thread Priority:{5}\n",
            //    //获取当前托管线程的唯一标识符
            //      thread.ManagedThreadId,
            //    //返回当前线程正在其中运行的当前域Id
            //      Thread.GetDomainID(),
            //    //返回当前线程正在其中运行的上下文Id
            //      Thread.CurrentContext.ContextID,
            //    //获取或设置线程的名称
            //      thread.Name,
            //    //获取一个值，该值包含当前线程的状态
            //      thread.ThreadState,
            //    //获取或设置一个值，该值指示线程的调度优先级
            //      thread.Priority);

            //Console.WriteLine(threadMessage); 
            #endregion

            #region 02.ThreadStart委托（无参）

            //Console.WriteLine("The Main ThreadId is:" + Thread.CurrentThread.ManagedThreadId);
            //Message02 message = new Message02();
            ////新线程的开启不会影响主线程的执行
            //Thread thread = new Thread(new ThreadStart(message.ShowMessage));
            //thread.Start();
            //Console.WriteLine("Do something.....!");
            //Console.WriteLine("Main Thread is completed");

            #endregion

            #region 03.ParameterizedThreadStart委托（传参）

            //Console.WriteLine("Main threadId is :"+Thread.CurrentThread.ManagedThreadId);
            //Message03 message = new Message03();
            //Thread thread = new Thread(new ParameterizedThreadStart(message.ShowMessage));
            ////将新启动的异步线程设置为异步线程
            //thread.IsBackground = true;
            //Person03 person03 = new Person03() {Name = "XuWangBin",Age = 25};
            //thread.Start(person03);
            //Console.WriteLine("Do something.....!");
            //Console.WriteLine("Main Thread is completed");
            //Console.WriteLine("Main Thread is Sleep");
            ////主线程挂起
            ////Thread.Sleep(1500);
            ////保证主线程在异步线程运行结束后才结束
            ////thread.Join();

            #endregion

            #region 04.Abort终止线程

            //Console.WriteLine("The Main theadId is:"+Thread.CurrentThread.ManagedThreadId);
            //Thread thread = new Thread(new ThreadStart(AsyncThread));
            //thread.IsBackground = true;
            //thread.Start();
            //thread.Join();

            #endregion

            #region 05.ManualResetEvent

            Console.WriteLine("****************************");
            Console.WriteLine("输入\"stop\"停止线程运行...");
            Console.WriteLine("输入\"run\"开启线程运行...");
            Console.WriteLine("****************************\r\n");

            MreClass objMRE = new MreClass();
            objMRE.CreateThreads();

            while (true)
            {
                string input = Console.ReadLine();
                if (input.Trim().ToLower() == "stop")
                {
                    Console.WriteLine("线程已停止运行...");
                    objMRE.Reset();
                }
                else if (input.Trim().ToLower() == "run")
                {
                    Console.WriteLine("线程开启运行...");
                    objMRE.Set();
                }
            }

            #endregion

            Console.ReadKey();
        }

        #region 02.ThreadStart委托--相关类
        public class Message02
        {
            public void ShowMessage()
            {
                string message = string.Format("Async threadId is :{0}", Thread.CurrentThread.ManagedThreadId);
                Console.WriteLine(message);
                for (int i = 0; i < 10; i++)
                {
                    Thread.Sleep(300);
                    Console.WriteLine("The number is:" + i.ToString());
                }
            }
        }
        #endregion

        #region 03.ParameterizedThreadStart委托--相关类
        public class Person03
        {
            public string Name { get; set; }
            public int Age { get; set; }
        }

        public class Message03
        {
            public void ShowMessage(object person)
            {
                if (person != null)
                {
                    Person03 _person = person as Person03;
                    string message = string.Format("{0}'s age is {1}!\nAsync threadId is:{2}",
                        _person.Name, _person.Age, Thread.CurrentThread.ManagedThreadId);
                    Console.WriteLine(message);
                }
                for (int i = 0; i < 10; i++)
                {
                    Thread.Sleep(300);
                    Console.WriteLine("The number is:" + i.ToString());
                }
            }
        }
        #endregion

        #region 04.Abort终止线程--相关方法

        static void AsyncThread()
        {
            try
            {
                string message = string.Format("Asyn threadId is {0}", Thread.CurrentThread.ManagedThreadId);
                Console.WriteLine(message);

                for (int i = 0; i < 10; i++)
                {
                    //当i等于4则终止线程
                    if (i >= 4)
                    {
                        Thread.CurrentThread.Abort(i);
                    }
                    Thread.Sleep(300);
                    Console.WriteLine("The number is {0}", i.ToString());
                }
            }
            catch (ThreadAbortException ex)
            {
                //输出终止线程时的i值
                if (ex.ExceptionState != null) Console.WriteLine(string.Format("Thread Abort when i is: {0}!", ex.ExceptionState.ToString()));
                //取消终止，继续执行线程
                Thread.ResetAbort();
                Console.WriteLine("Thread ResetAbort");
            }
            Console.WriteLine("Thread Close!");
        }

        #endregion

        #region 05.ManualResetEvent--相关类

        public class MreClass
        {
            private ManualResetEvent _mre;

            public MreClass()
            {
                _mre = new ManualResetEvent(false);
            }
            public void CreateThreads()
            {
                Thread t1 = new Thread(new ThreadStart(Run));
                t1.Start();

                Thread t2 = new Thread(new ThreadStart(Run));
                t2.Start();
            }

            public void Set()
            {
                this._mre.Set();
            }

            public void Reset()
            {
                this._mre.Reset();
            }

            private void Run()
            {
                string strThreadId = string.Empty;
                try
                {
                    while (true)
                    {
                        // 阻塞当前线程
                        this._mre.WaitOne();

                        strThreadId = Thread.CurrentThread.ManagedThreadId.ToString();
                        Console.WriteLine("Thread(" + strThreadId + ") is running...");

                        Thread.Sleep(5000);
                    }
                }
                catch (Exception ex)
                {
                    Console.WriteLine("线程(" + strThreadId + ")发生异常！错误描述：" + ex.Message.ToString());
                }
            }
        }

        #endregion

    }




}
