﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Runtime.Remoting.Messaging;
using System.Text;
using System.Threading;

namespace _02ThreadPool
{
    class Program
    {
        static void Main(string[] args)
        {
            #region 01.QueueUserWorkItem启动工作者线程

            //ThreadPool.SetMaxThreads(1000, 1000);
            ////显示主线程的启动信息
            //ThreadMessage("Main Thread");
            ////启动工作线程
            //ThreadPool.QueueUserWorkItem(new WaitCallback(AsyncCallBack),"Hello Word");

            #endregion

            #region 02.委托类方法

            //MyDelegate dDelegate = new MyDelegate(DelegateTest);
            ////显示委托的成员方法
            //var methods = dDelegate.GetType().GetMethods();
            //foreach (MethodInfo methodInfo in methods)
            //{
            //    Console.WriteLine(methodInfo.Name); 
            //}
            #endregion

            #region 03.BeginInvoke与EndInvoke异步委托

            //ThreadMessage("Main Thread");

            ////建立委托
            //MyAsyncDelegate myAsyncDelegate = SayHello;
            ////异步调用,获取异步线程执行结果
            //IAsyncResult result = myAsyncDelegate.BeginInvoke("Xwb", null, null);

            //////轮询方式检测异步线程执行情况，可实现--主线程在异步线程执行结束前进行一些操作
            ////while (!result.IsCompleted)
            ////{
            ////    Console.WriteLine("Before Async Main Thread can do other things!");
            ////}

            //while (!result.AsyncWaitHandle.WaitOne())
            //{
            //    Console.WriteLine("Before Async Main Thread can do other things!");
            //}

            //Console.WriteLine("Do other Main Thread's work...");

            ////等待异步线程执行完毕，用EndInvoke(IAsyncResult) 获得结果
            //string data = myAsyncDelegate.EndInvoke(result);
            //Console.WriteLine("Main Thread completed,the result is {0}", data);

            #endregion

            #region 04.回调函数
            
            ThreadMessage("Main thread");

            //建立委托
            MyAsyncDelegate myAsyncDelegate = new MyAsyncDelegate(SayHello);
            //异步调用，获取结果
            myAsyncDelegate.BeginInvoke("Xwb", new AsyncCallback(Completed), null);
            //启动异步线程后主线程可以继续工作而不需等待
            for (int i = 0; i < 6; i++)
                Console.WriteLine("Main thread do work!");
            Console.WriteLine();

            #endregion

            Console.ReadKey();
        }

        #region 01.QueueUserWorkItem启动工作者线程--相关方法

        static void AsyncCallBack(object state)
        {
            Thread.Sleep(300);
            ThreadMessage("AsynCallBack");

            string data = state as string;
            Console.WriteLine("Asyn Thread is working!\nExtensionData:" + data);
        }

        //线程状态显示
        static void ThreadMessage(string data)
        {
            string message = string.Format("{0} threadId is:{1}", data, Thread.CurrentThread.ManagedThreadId);
            Console.WriteLine(message);
        }

        #endregion

        #region 02.委托类方法--相关定义

        delegate void MyDelegate();

        static void DelegateTest()
        {
        }

        #endregion

        #region 03.BeginInvoke与EndInvoke异步委托--相关方法

        static string SayHello(string name)
        {
            ThreadMessage("Async Thread");
            //模拟异步线程的操作
            Console.WriteLine("Async Thread begin work...");
            Thread.Sleep(2000);
            Console.WriteLine("Async Thread end work...");
            return "Hello" + name;
        }

        delegate string MyAsyncDelegate(string name);

        #endregion

        #region 04.回调函数--相关方法

        static void Completed(IAsyncResult result)
        {
            ThreadMessage("Async thread");

            //获取委托对象，调用EndInvoke方法获取运行结果
            AsyncResult _result = result as AsyncResult;
            MyAsyncDelegate myAsyncDelegate = _result.AsyncDelegate as MyAsyncDelegate;
            string data = myAsyncDelegate.EndInvoke(_result);
            Console.WriteLine(data);
        }
        
        #endregion
    }
}
