﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;

namespace _03IOThread
{
    class Program
    {
        static void Main(string[] args)
        {
            #region 01.FileStream异步写入

            ////线程池最大值设置为1000
            //ThreadPool.SetMaxThreads(1000, 1000);
            //ThreadPoolMessage("Main Thread");

            ////建立File源
            //FileStream stream = new FileStream("testFileStream.sour", FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite, 1024, true);

            //Byte[] bytes = new byte[18654];
            //string message = "I love you,and you love!Entity Framework is very useful!";
            //bytes = Encoding.Unicode.GetBytes(message);

            ////异步写入
            //stream.BeginWrite(bytes, 0, bytes.Length, CallBackMethod, stream);
            //stream.Flush();

            //Console.WriteLine("Main Thread completed!");

            #endregion

            #region 02.FileStream异步读取

            //线程池最大值设置为1000
            ThreadPool.SetMaxThreads(1000, 1000);
            ThreadPoolMessage("Main Thread");

            ReadFile();
            Console.WriteLine("Main Thread completed!");

            #endregion

            Console.ReadKey();

        }

        #region 01.FileStream异步写入--相关方法

        static void CallBackMethod(IAsyncResult result)
        {
            //显示线程池状态
            Thread.Sleep(2000);
            ThreadPoolMessage("AsyncCallback");
            //结束异步写入
            FileStream stream = result.AsyncState as FileStream;
            stream.EndWrite(result);
            stream.Close();
        }

        /// <summary>
        /// 显示线程池的状态
        /// </summary>
        /// <param name="data"></param>
        private static void ThreadPoolMessage(string data)
        {
            int workerThreadsCount, completionPortThreadsCount;
            ThreadPool.GetAvailableThreads(out workerThreadsCount, out  completionPortThreadsCount);
            string message = string.Format("{0}\n CurrentThreadId is{1}\n" +
                                           "WorkerThreadsCount is {2} CompletionPortThreadsCount is {3}",
                                           data, Thread.CurrentThread.ManagedThreadId, workerThreadsCount, completionPortThreadsCount);
            Console.WriteLine(message);
        }

        #endregion

        #region 02.FileStream异步读取--相关类、方法

        public class FileData
        {
            public FileStream Stream;
            public int Length;
            public byte[] ByteData;
        }

        private static void ReadFile()
        {
            byte[] byteData = new byte[80961014];
            FileStream stream = new FileStream("testFileStream.sour", FileMode.OpenOrCreate, FileAccess.ReadWrite,
                                               FileShare.ReadWrite, 1024, true);

            //把参数封装FileData对象以作为附加参数添加到回调函数中去
            var fileData = new FileData() { Stream = stream, Length = (int)stream.Length, ByteData = byteData };
            stream.BeginRead(byteData, 0, byteData.Length, ReadCallBack, fileData);
        }

        //读取回调函数
        static void ReadCallBack(IAsyncResult result)
        {
            Thread.Sleep(2000);
            ThreadPoolMessage("Async Thead");

            //获得附加FileData对象
            FileData fileData = (FileData)result.AsyncState;
            int length = fileData.Stream.EndRead(result);
            fileData.Stream.Close();

            if (length != fileData.Length)
            throw new Exception("Stream is not Compeleted!");

            string data = Encoding.ASCII.GetString(fileData.ByteData, 0, fileData.Length);
            Console.WriteLine(data);
        }

        #endregion
    }
}
