﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;

namespace _04SocketThread
{
    class Program
    {
        static byte[] buffer = new byte[1024];

        static void Main(string[] args)
        {
            //创建基于TCP的流式TCP套接字
            var socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            //绑定某个端口
            socket.Bind(new IPEndPoint(IPAddress.Any, 4554));
            //启动监听，设置监听队列
            socket.Listen(10);

            socket.BeginAccept(ClientAcceptCallBack, socket);

            Console.WriteLine("Server is Ready！");
            Console.ReadKey();
        }

        //客户端接收
        static void ClientAcceptCallBack(IAsyncResult result)
        {
            var socket = (Socket) result.AsyncState;

            //得到客户端socket实例
            var clientScoket = socket.EndAccept(result);

            //向客户端发送信息
            clientScoket.Send(Encoding.Unicode.GetBytes("Hi,I accept your request at " + DateTime.Now.ToString()));

            //每两秒钟向客户端发送信息
            var timer = new System.Timers.Timer();
            timer.Interval = 2000D;
            timer.Enabled = true;
            timer.Elapsed += (o, a) =>
            {
                //检测客户端连接状态
                if (clientScoket.Connected)
                {
                    try
                    {
                        clientScoket.Send(Encoding.Unicode.GetBytes("I accept your orther request at " + DateTime.Now.ToString()));
                    }
                    catch (SocketException ex)
                    {
                        Console.WriteLine(ex.Message);
                    }
                }
                else
                {
                    timer.Stop();
                    timer.Enabled = false;
                    Console.WriteLine("Client is not contect,timer is stop!");
                }
            };
            timer.Start();

            clientScoket.BeginReceive(buffer, 0, buffer.Length, SocketFlags.None, new AsyncCallback(ReceiveCallBack), clientScoket);
            
            //服务端递归调用，准备接收下一个客户端请求
            socket.BeginAccept(ClientAcceptCallBack, socket);
        }

        //回调接收方法
        static void ReceiveCallBack(IAsyncResult result)
        {
            try
            {
                //得到客户端socket
                Socket socket = (Socket)result.AsyncState;
                int length = socket.EndReceive(result);
                string message = Encoding.Unicode.GetString(buffer, 0, length);
                Console.WriteLine(message + " from " + socket.RemoteEndPoint.ToString());
                socket.BeginReceive(buffer, 0, buffer.Length, SocketFlags.None, new AsyncCallback(ReceiveCallBack), socket);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        
    }
}
