﻿using System;
using System.Net.Sockets;
using System.Text;

namespace _05SocketThreadClient
{
    class Program
    {
        //设置缓存区接收信息
        static readonly byte[] Buffer = new byte[1024];

        static void Main(string[] args)
        {
            //创建一个客户端socket
            var socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            //与指定服务器端口连接
            socket.Connect("localhost", 4554);           
            
            //socket.BeginReceive(buffer, 0, buffer.Length, SocketFlags.None, new AsyncCallback(ar =>
            //    {
            //        var length = socket.EndReceive(ar);
            //        var message = Encoding.Unicode.GetString(buffer, 0, length);
            //        Console.WriteLine(message);
            //    }), null);

            socket.BeginReceive(Buffer, 0, Buffer.Length, SocketFlags.None, new AsyncCallback(ReceiveCallBack), socket);

            //接收用户信息
            while (true)
            {
                var message = "Message form Client: " + Console.ReadLine();
                var outBuffer = Encoding.Unicode.GetBytes(message);
                socket.BeginSend(outBuffer, 0, outBuffer.Length, SocketFlags.None, null, null);
            }

            Console.WriteLine("Connect to Server!");
            Console.ReadKey();
        }

        //接收回调方法
        static void ReceiveCallBack(IAsyncResult result)
        {
            //得到客户端socket
            var socket = (Socket) result.AsyncState;
            var length = socket.EndReceive(result);
            var message = Encoding.Unicode.GetString(Buffer, 0, length);
            Console.WriteLine(message);

            //递归回调接收数据
            socket.BeginReceive(Buffer, 0, Buffer.Length, SocketFlags.None, new AsyncCallback(ReceiveCallBack), socket);
        }
    }
}
