﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading;
using _05_3WebRequestModel;

namespace _05_2WebRequestClient
{
    class Program
    {
        static void Main(string[] args)
        {
            ThreadPool.SetMaxThreads(1000, 1000);
            Request();
            Console.ReadKey();
        }

        static void Request()
        {
            ThreadPoolMessage("Main Thread");
            //建立WebRequest对象
            HttpWebRequest webRequest = WebRequest.Create("http://localhost:12131/Handler.ashx") as HttpWebRequest;
            webRequest.Method = "post";

            //异步请求
            webRequest.BeginGetRequestStream(EndGetRequestStream, webRequest);
        }

        //请求流的回调函数
        static void EndGetRequestStream(IAsyncResult result)
        {
            ThreadPoolMessage("RequestStream Compeleted!");
            HttpWebRequest webRequest = (HttpWebRequest)result.AsyncState;
            Stream stream = webRequest.EndGetRequestStream(result);

            //写入请求条件
            byte[] condition = Encoding.Unicode.GetBytes("Id:1");
            stream.Write(condition, 0, condition.Length);

            //异步接收回传信息
            webRequest.BeginGetResponse(EndGetResponse, webRequest);
        }

        //相应流的回调函数
        private static void EndGetResponse(IAsyncResult result)
        {
            ThreadPoolMessage("EndGetResponse Compeleted!");

            //结束异步，获取结果
            HttpWebRequest webRequest = (HttpWebRequest)result.AsyncState;
            WebResponse webResponse = webRequest.EndGetResponse(result);

            //把接收结果转化为Person对象并输出
            Stream stream = webResponse.GetResponseStream();
            BinaryFormatter formatter = new BinaryFormatter();
            var person = (Person)formatter.Deserialize(stream);
            Console.WriteLine(string.Format("Person Id:{0},Name:{1},Age:{2}", person.Id, person.Name, person.Age));

        }

        // 显示线程池的状态
        private static void ThreadPoolMessage(string data)
        {
            int workerThreadsCount, completionPortThreadsCount;
            ThreadPool.GetAvailableThreads(out workerThreadsCount, out  completionPortThreadsCount);
            string message = string.Format("{0}\n CurrentThreadId is{1}\n" +
                                           "WorkerThreadsCount is {2} CompletionPortThreadsCount is {3}",
                                           data, Thread.CurrentThread.ManagedThreadId, workerThreadsCount, completionPortThreadsCount);
            Console.WriteLine(message);
        }
    }
}
