﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Web;
using _05_3WebRequestModel;

namespace _06WebRequestServer
{
    /// <summary>
    /// Summary description for Handler
    /// </summary>
    public class Handler : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            //把信息转换为string，找出条件Id
            byte[] bytes = new byte[1024];
            int length = context.Request.InputStream.Read(bytes, 0, 1024);
            string condition = Encoding.Unicode.GetString(bytes, 0, length);
            int id = int.Parse(condition.Split(new string[] { ":" }, StringSplitOptions.RemoveEmptyEntries)[1]);

            //根据Id查找对象
            var person = GetPersonList().First(p => p.Id == id);

            //Person格式转化为二进制数据写入OutputStream
            BinaryFormatter formatter = new BinaryFormatter();
            formatter.Serialize(context.Response.OutputStream, person);
        }

        public bool IsReusable
        {
            get
            {
                return true;
            }
        }

        //模拟源数据
        private IEnumerable<Person> GetPersonList()
        {
            var personList = new List<Person>();
            personList.Add(new Person() { Id = 1, Name = "Xwb", Age = 25 });
            return personList;
        }
    }
}